unit inioptions; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Buttons, Spin, Menus;

type

  { TFormINI }

  TFormINI = class(TForm)
    ButtonINI: TButton;
    ButtonAUTO: TButton;
    buttonLOG: TButton;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    Label1: TLabel;
    Label2: TLabel;
    MemoINI: TMemo;
    MemoAUTO: TMemo;
    MemoLOG: TMemo;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonINIClick(Sender: TObject);
    procedure ButtonAUtoClick(Sender: TObject);
    procedure ButtonLOGClick(Sender: TObject);

    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormINI: TFormINI;

implementation uses main, loadcoe;

{ TFormINI }


procedure TFormINI.FormCreate(Sender: TObject);
          begin

          MemoINI.Lines.LoadFromFile('gravimagic.ini');
          MemoAuto.Lines.LoadFromFile('automagic.ini');
          MemoLOG.Lines.LoadFromFile('gravimagic.log');
          end;





procedure TFormINI.ButtonOKClick(Sender: TObject);
          begin
          Mainform.LoadAutoMagic;
          LoadParameters('gravimagic.ini');
          check.LoadSet;
          end;


procedure TFormINI.ButtonINIClick(Sender: TObject);
          begin
          MemoINI.Lines.SaveToFile('gravimagic.ini');
          end;

procedure TFormINI.ButtonAutoClick(Sender: TObject);
          begin
          MemoAuto.Lines.SaveToFile('automagic.ini');
          end;

procedure TFormINI.ButtonLOGClick(Sender: TObject);
          begin
          MemoLOG.Lines.SaveToFile('gravimagic.log');
          end;

initialization
  {$I inioptions.lrs}

end.

