 program Montage3;
 Uses typer,crt,opcrt,opmouse,mliber,ptr_new,data,redactor,files;

 var    inp_name     : string;
        out_name     : string;
        spath        : string;

 type tcheck = object

     dat       : tdat;     {室 ᨢ}
     nx,ny     : longint;
     xa,xb     : real;
     ya,yb     : real;
     dx,dy     : real;
     x1,x2   : integer;
     y1,y2   : integer;

        minlevel : real;
        maxlevel : real;

      disp      : real;
      disp0      : real;

      tower     : word;
     finish     : psuper;

       main     : tmainmenu;
      smain     : tarray;

   filemenu     : tmenu;
      sfile     : tarray;
      nfile     : word;

    runmenu     : tmenu;
       srun     : tarray;

 globalmenu     : tmenu;
    sglobal     : tarray;

 sgeomethod     : array[1..3] of string;
  geomethod     : 1..3;

 selectfile     : boolean;
       scan     : byte;

 Constructor  Create;
  Destructor  Done;
    function  Loaddata:boolean;
    procedure Init;
    procedure SetGlobalParameters(x,y,k:word;ed:boolean);
    procedure ShowGlobalParameters(x,y:word);
    procedure WorkOfFile(x,y:byte);
    procedure WorkOfRun(x,y:byte);
    procedure WorkOfGlobal(x,y:byte);
    procedure SearchFiles(s:string;var mf:word);
    function  gets(i,k,t:longint):real;
   procedure  puts(i,k,t:longint;z:real);
    function  Dispersy:real;
    function  Wav(x,h,ho,dens:real):real;
    procedure Refresh(xo,ho,dens:real);
    procedure FinishPut(k:longint;x,h,d:real);
    function  Extremal(i,k:longint):real;
    function  CheckMNKPoint(k,i:longint):boolean;
    function  SearchX(k:longint;var it:longint):boolean;
    procedure SearchAll;

 end;

{==============================Begin=Tcheck==================================}
   Constructor  tcheck.Create;
                Begin
                selectfile:=false;
                minlevel:=-0.018;
                maxlevel:=+0.006;

                new(finish,create(600,4));
                tower:=0;

                inp_name:='noname.wav';
                out_name:='noname.dat';

                Clearwindow(white,black,1,1,81,4,' ');
                gotoxy(1,1);
                TextBackground(black);
                textcolor(Lightgray);
                writeln('  㦥!');
                textcolor(red);
                writeln(' : ',inp_name+'      ');
                writeln('뢮: ',out_name+'      ');
                writeln(':  ',spath+    '      ');
                clearwindow(blue,black,1,5,81,20,'');{944-946}
                End;

    Destructor  tcheck.Done;
                Begin
                dispose(finish,done);
                dat.done;
                End;

      function  tcheck.Loaddata:boolean;
                var   i : longint;
                      sx: longint;
                      sy: longint;
                      c : real;
                Begin
                with dat do
                begin
                create(spath,inp_name);
                load(1);
                sx:=0;
                sy:=0;
                c:=get_(1,1);
                for i:=1 to all do
                if c=get_(i,1) then sy:=sy+1;

                c:=get_(1,2);
                if (c<>get_(2,2)) then begin writeln('訡:   ஢   <B>');halt;end;
                for i:=1 to all do
                if c=get_(i,2) then sx:=sx+1;

                nx:=sx;
                ny:=sy;

                xa:=min[1];
                xb:=max[1];
                ya:=min[2];
                yb:=max[2];
                dx:=(xb-xa)/(nx-1);
                dy:=(yb-ya)/(ny-1);

                maxlevel:=+dat.St_d[3];
                minlevel:=-3*dat.St_d[3];

                gotoxy(1,1);
                TextBackground(black);
                textcolor(Lightgray);
                writeln(' [', nx,',',ny,'] ᯥ譮 㦥 [OK]');
                end;
                textcolor(red);
                writeln(' : ',inp_name);
                writeln('뢮: ',out_name);
                writeln(' :  ',spath);
                selectfile:=true;
                runmenu.access[1]:=true;
                disp:=dispersy;
                disp0:=disp;
                End;

   procedure    tcheck.Init;
                Begin
                smain[1]:='       ';
                smain[2]:=' ᫥ ';
                smain[3]:=' ࠬ ';
                smain[4]:='   室   ';

                {ࠬ 㡠}
                srun[1]:='  ᫥ >>           ';
                srun[2]:=' << ⪠                       ';

                {騥 ࠬ}
                sgeomethod[1]:='ࠢ';
                sgeomethod[2]:='⪠';
                sgeomethod[3]:='';
                geomethod:=1;{ࠢ}

                sglobal[1]:='  ஢   ';
                sglobal[2]:=' ᨬ ஢  ';
                sglobal[3]:='  䠩             ';
                sglobal[4]:=' ⮤                 ';
                sglobal[5]:='  ணࠬ                        ';
                sglobal[6]:=' << ⪠                           ';
                End;

   procedure   tcheck.SetGlobalParameters(x,y,k:word;ed:boolean);
               var s:string;
                   ct,cb:byte;
                   code:longint;
                   tx:word;
               Begin
               tx:=23;
               if ed
               then begin cb:=Black;ct:=Yellow;end
               else begin cb:=cyan;ct:=black{cyan};end;

               case k of
                1:begin
                  s:=fstr(minlevel,5);
                  EditMath(x+tx,y+k,12,ct,cb,s,ed);
                  val(s,minlevel,code);
                  EditMath(x+tx,y+k,12,black,cyan,s,false);
                  end;
                2:begin
                  s:=fstr(maxlevel,5);
                  EditMath(x+tx,y+k,12,ct,cb,s,ed);
                  val(s,maxlevel,code);
                  EditMath(x+tx,y+k,12,black,cyan,s,false);
                  end;
                3:begin
                  s:=out_name;
                  Edit(x+tx,y+k,12,ct,cb,s,ed);
                  out_name:=s;
                  Edit(x+tx,y+k,12,black,cyan,s,false);
                  gotoxy(1,3);
                  textcolor(red);
                  TextBackground(black);
                  writeln('뢮: ',out_name+'      ');
                  end;
                4:begin
                  if ed then
                  begin
                  if (geomethod=3)
                  then geomethod:=1
                  else geomethod:=geomethod+1;
                  end;
                  s:=sgeomethod[geomethod];
                  Edit(x+tx,y+k,12,black,cyan,s,false);
                  end;
               end;
               End;

   procedure   tcheck.ShowGlobalParameters(x,y:word);
               var i:byte;
               Begin
               for i:=1 to 4 do SetGlobalParameters(x,y,i,false);
               End;

   procedure   tcheck.WorkOfFile(x,y:byte);
               var i:byte;
                   s:string;
               Begin

               with Filemenu do
               begin
               Copymenu(x,y);
               repeat
               if SelectMenu(x,y,activ)
               then
               begin
               inp_name:=sfile[activ];

               s:=inp_name;
               delete(s,pos('.',s)+1,3);
               insert('dat',s,pos('.',s)+1);
               out_name:='_'+s;

               clearLine(black,black,1,81,21);
               clearLine(black,black,1,81,22);
               clearLine(black,black,1,81,1);
               clearLine(black,black,1,81,2);
               textcolor(red);
               gotoxy(1,2);
               writeln('  : ',inp_name+'   ');
               writeln('뢮 : ',out_name+'   ');


               if selectfile then dat.done;
               LoadData;
               Init;
               break;
               end {if SelectMenu then}
               else break;
               until (scan=0);

               Clearmenu(x,y);
               end;{with}
               End;

   procedure   tcheck.WorkOfRun(x,y:byte);
               Begin
               with Runmenu do
               begin
               Copymenu(x,y);
               repeat
               if SelectMenu(x,y,activ)
               then
               begin
               case activ of
            1: begin SearchAll;;break; end;
            2: begin break; end;
               end;
               end
               else break;
               until (scan=0);

               Clearmenu(x,y);
               end;
               End;

   procedure   tcheck.WorkOfGlobal(x,y:byte);
               var i:byte;
               Begin
               with Globalmenu do
               begin
               Copymenu(x,y);
               ShowGlobalParameters(x,y+1);
               repeat
               if SelectMenu(x,y,activ)
               then
               begin

               case activ of
          1..4: begin SetGlobalParameters(x,y+1,activ,true);end;
             5: begin MovedLineMessage('⠦ 筪; 񬮢 .., , 2003',yellow,black,black,100,24);end;
             6: begin break; end;
               end;
               end
               else break;
               until (scan=0);

               Clearmenu(x,y);
               end;
               End;

     procedure  tcheck.SearchFiles(s:string;var mf:word);
                Begin
                mf:=10;
                Get_files(s,'',nfile,sfile);
                sort(nfile,sfile);
                reform(nfile,8,sfile);
                if (mf>nfile) then mf:=nfile;
                End;

    function    tcheck.gets(i,k,t:longint):real;
                Begin
                gets:=dat.get_(nx*(k-1)+i,t);
                End;

   procedure    tcheck.puts(i,k,t:longint;z:real);
                Begin
                dat.put_(nx*(k-1)+i,t,z);
                End;

      function  tcheck.Dispersy:real;
                var i,k:longint;
                    mean,d,s:real;
                Begin
                {
                mean:=0;
                for i:=1 to nx do
                for k:=1 to ny do
                begin
                mean:=mean+gets(i,k,3);
                end;
                mean:=mean/nx/ny;

                mean:=dat.aver[3];
                }
                s:=0;
                for i:=1 to nx do
                for k:=1 to ny do
                begin
                s:=s+sqr((gets(i,k,3){-mean}){/gets(i,k,2)});
                end;
                Dispersy:={sqrt}(s/(nx*ny));
                End;


      function  tcheck.Wav(x,h,ho,dens:real):real;
                var s,t,q:real;
                Begin
                case geomethod of
            1,2:begin
                s:=h+ho;
                t:=sqr(x/s);
                q:=sqr(s*(1+t));
                wav:=dens*16*sqr(ho*h)*(1+sqr(t)-6*t)/sqr(q);
                end;
              3:begin
                s:=sqr(h)+sqr(ho);
                t:=sqr(x)/s;
                wav:=dens*sqrt(4*ho/pi)*ho*h/s*sqrt(2*pi*h/s)*(1-t)*exp(-t/2);
                end;
                end;
                End;

   procedure    tcheck.FinishPut(k:longint;x,h,d:real);
                var c:real;
                Begin
                with finish^ do
                begin

                case geomethod of
            1,2:c:=pi*sqr(h)*1/6;
              3:c:=sqrt(4*h/pi);
                end;

                put_(k,1,x);
                put_(k,2,h);
                put_(k,3,d);
                put_(k,4,c*d);
                end;
                End;

   procedure    tcheck.Refresh(xo,ho,dens:real);
                var i,j,k:longint;
                    x,y,h:real;
                Begin
                for i:=1 to nx do
                for k:=1 to ny do
                begin
                x:=gets(i,k,1);
                h:=gets(i,k,2);
                puts(i,k,3,gets(i,k,3)-wav(x-xo,h,ho,dens));
                end;
                End;

    function    tcheck.Extremal(i,k:longint):real;
                var cx1,cx2,cy1,cy2,co:real;
                    t:real;
                Begin
                 co:=gets(i,k,3);
                cx1:=gets(i-1,k,3);
                cx2:=gets(i+1,k,3);
                cy1:=gets(i,k-1,3);
                cy2:=gets(i,k+1,3);
                if
                (
                (((co>cx1) and (co>cx2)) and ((co>cy1) and (co>cy2)))
                )
                or
                (
                (((co<cx1) and (co<cx2)) and ((co<cy1) and (co<cy2)))
                )
                then t:=co
                else t:=0;
                Extremal:=t;
                End;

    function    tcheck.CheckMNKPoint(k,i:longint):boolean;
                var d:real;
                    xo,ho,dens:real;
                Begin
                xo:=gets(i,k,1);
                ho:=gets(i,k,2);
                dens:=gets(i,k,3);

                Refresh(xo,ho,dens);


                d:=dispersy;
                if (d<=disp)
                then
                begin
                disp:=d;
                Refresh(xo,ho,-dens);
                CheckMNKPoint:=true;
                exit;
                end
                else
                begin
                Refresh(xo,ho,-dens);
                CheckMNKPoint:=false;
                exit;
                end;
                End;


   function    tcheck.SearchX(k:longint;var it:longint):boolean;
                var i:longint;
                    test:real;
                    minmax:real;
                    b:boolean;
                Begin
                b:=false;
                minmax:=-1e10;
                for i:=2 to nx-1 do
                begin
                test:=Extremal(i,k);
                if ((test>maxlevel) or (test<minlevel)) and (abs(test)>minmax)
                then
                begin
                minmax:=abs(test);
                it:=i;
                b:=true;
                end;{if}
                end;{i}
                SearchX:=b;
                End;

   procedure    tcheck.SearchAll;
                var c,k,i,j:longint;
                    b:boolean;
                    xo,ho,dens:real;
                    ch:char;
                    f:real;
                Begin
                c:=0;

                for k:=2 to nx-1 do
                begin

                repeat
                if SearchX(k,i) and CheckMNKPoint(k,i)
                then
                begin
                {CheckMNKPoint(k,i);}
                c:=c+1;

                xo:=  gets(i,k,1);
                ho:=  gets(i,k,2);
                dens:=gets(i,k,3);

                case geomethod of
            1,2:f:=pi*sqr(ho)*1/6;
              3:f:=sqrt(4*ho/pi);
                end;

                if CheckofKey(27) then begin ch:=#27;break;end;

                finishPut(c,xo,ho,dens);
                Refresh(xo,ho,dens);


                TextBackground(black);
                gotoxy(1,21);
                textcolor(lightgray);
                write('筨 : ');
                textcolor(yellow);
                write('[',c,']');
                textcolor(lightgray);
                write('  : ');
                textcolor(yellow);
                write(disp/disp0:10:10,'  ');
                gotoxy(7,22);
                textcolor(lightgray);write('㡨   : ');textcolor(yellow);write(ho:0:2,'   ');
                gotoxy(7,23);
                textcolor(lightgray);write(' x : ');textcolor(yellow);write(xo:0:2);
                gotoxy(7,24);
                textcolor(lightgray);write('⭮ : ');textcolor(yellow);write(dens*f:0:3,' [',minlevel*f:0:3,' .. ',maxlevel*f:0:3,']   ');
                textcolor(Lightgray);

                end
                else break;
                {readkey;}

                until (ch=#27);

                if ch=#27 then
                begin
                clearwindow(black,black,1,21,80,24,' ');
                LineMessage('ணࠬ ࢠ',red,black,black,1500,21);
                exit;
                end;
                end;

                finish^.out_(spath,out_name,c);

                clearwindow(black,black,1,21,80,24,' ');
                gotoxy(1,21);
                TextBackground(black);
                textcolor(Lightgray);
                writeln(': ',c,' 筨//');
                writeln('筮     : ',disp/disp0*100:0:3,'%');

                End;




{================================End=Tcheck==================================}
  var check:tcheck;
     i,x,y:byte;
     mf:word;


 Begin
 clrscr;
 Getdir(0,spath);
 if length(spath)>3 then spath:=spath+'\';

 InitializeMouse;
 EnableEventHandling;
 ShowMouse;

 x:=15;
 y:=5;

 with check do
 begin

 Create;
 Init;
 main.create(smain,4,4);

 SearchFiles('wav',mf);

 filemenu.create(sfile,nfile,mf);
 if nfile=0 then main.access[1]:=false;

 globalmenu.create(sglobal,6,6);
 runmenu.create(srun,2,2);

 if not selectfile then runmenu.access[1]:=false;

 scan:=2;
 with main do
 begin
 repeat

   if SelectMenu(x,y,activ)
   then
   case activ of
   1: workOfFile(x,y+0);
   2: workOfRun(x+7,y+0);
   3: workOfglobal(x+16,y+0);
   4: begin break;end;
   end;
 until scan=1;
 done;
 end;

 filemenu.done;
 runmenu.done;
 globalmenu.done;
 main.done;

 if selectfile then Done;
 end;
 Clearwindow(white,black,1,1,81,24,' ');
 gotoxy(1,25);
 End.



