unit exportdata;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,main,
  Buttons, ExtCtrls, EditBtn, StdCtrls;

type

  { TFormexport }

  TFormexport = class(TForm)
    bottonOK: TButton;
    Buttoncancel: TButton;
    CheckGroupexport: TCheckGroup;
    EditSuffix: TEdit;
    FileNameEditexportSmooth: TFileNameEdit;
    FileNameEditexportplot: TFileNameEdit;
    FileNameEditexportsources: TFileNameEdit;
    FileNameEditexportkarkas: TFileNameEdit;
    FileNameEditexportmap: TFileNameEdit;
    Label1: TLabel;
    Label_s: TLabel;
    LabelSmooth: TLabel;
    Labelplots: TLabel;
    Labelsources: TLabel;
    Labelkarkas: TLabel;
    Labelwavemap: TLabel;
    procedure EditSuffixChange(Sender: TObject);
    procedure bottonOKClick(Sender: TObject);
    procedure CheckGroupexportItemClick(Sender: TObject; Index: integer);
    procedure FileNameEditexportmapChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Formexport: TFormexport;

implementation uses loadcoe;

{ TFormexport }



procedure TFormexport.CheckGroupexportItemClick(Sender: TObject; Index: integer);
          begin
          FileNameEditexportmap.Enabled:=CheckGroupexport.Checked[0];
          FileNameEditexportkarkas.Enabled:=CheckGroupexport.Checked[1];
          FileNameEditexportsources.Enabled:=CheckGroupexport.Checked[2];
          FileNameEditexportplot.Enabled:=CheckGroupexport.Checked[3];
          FileNameEditexportSmooth.Enabled:=CheckGroupexport.Checked[4];
          end;

procedure TFormexport.FileNameEditexportmapChange(Sender: TObject);
begin

end;

procedure TFormexport.FormCreate(Sender: TObject);
          var s:string;
          begin
          s:=EditSuffix.Text;
          with Mainform do
          begin
          FileNameEditexportplot.FileName:=newName(FileNameOpenEditor.filename,'_plot'+s,'dat');
          FileNameEditexportsources.FileName:=newName(FileNameOpenEditor.filename,'_sources'+s,'dat');
          FileNameEditexportkarkas.FileName:=newName(FileNameOpenEditor.filename,'_karkas'+s,'dat');
          FileNameEditexportmap.FileName:=newName(FileNameOpenEditor.filename,'_wavemap'+s,'grd');
          FileNameEditexportSmooth.FileName:=newName(FileNameOpenEditor.filename,'_smooth'+s,'grd');
          end;

          if not bmap then
          begin
          CheckGroupexport.Checked[0]:=false;
          CheckGroupexport.CheckEnabled[0]:=false;
          FileNameEditexportmap.Enabled:=false;
          end
          else
          begin
          CheckGroupexport.Checked[0]:=true;
          CheckGroupexport.CheckEnabled[0]:=true;
          FileNameEditexportmap.Enabled:=true;
          end;

          if not bkarkas then
          begin
          CheckGroupexport.Checked[1]:=false;
          CheckGroupexport.CheckEnabled[1]:=false;
          FileNameEditexportkarkas.Enabled:=false;
          end
          else
          begin
          CheckGroupexport.Checked[1]:=true;
          CheckGroupexport.CheckEnabled[1]:=true;
          FileNameEditexportkarkas.Enabled:=true;
          end;

          if not bsource then
          begin
          CheckGroupexport.Checked[2]:=false;
          CheckGroupexport.CheckEnabled[2]:=false;
          CheckGroupexport.Checked[3]:=false;
          CheckGroupexport.CheckEnabled[3]:=false;
          FileNameEditexportplot.Enabled:=false;
          FileNameEditexportsources.Enabled:=false;
          end
          else
          begin
          CheckGroupexport.Checked[2]:=true;
          CheckGroupexport.CheckEnabled[2]:=true;
          CheckGroupexport.Checked[3]:=true;
          CheckGroupexport.CheckEnabled[3]:=true;
          FileNameEditexportplot.Enabled:=true;
          FileNameEditexportsources.Enabled:=true;
          end;

          if not bsmooth then
          begin
          CheckGroupexport.Checked[4]:=false;
          CheckGroupexport.CheckEnabled[4]:=false;
          FileNameEditexportSmooth.Enabled:=false;
          end
          else
          begin
          CheckGroupexport.Checked[4]:=true;
          CheckGroupexport.CheckEnabled[4]:=true;
          FileNameEditexportSmooth.Enabled:=true;
          end;

          end;

procedure TFormexport.bottonOKClick(Sender: TObject);
                var i,k:word;
                    c,x,dx,y,dy:double;
                    f:textfile;
          begin
          with check do
          begin
          if CheckGroupexport.Checked[0] and bmap then
          begin
          dx:=(ox2-ox1)/(vmx-1);
          dy:=(oy2-oy1)/(vmy-1);

          assignfile(f,UTF8Decode(FileNameEditexportmap.FileName));
          rewrite(f);
          writeln(f,'DSAA');
          writeln(f, vmx,' ',vmy);
          writeln(f, ox1,' ',ox2);
          writeln(f, -oy2,' ',-oy1);
          writeln(f,vmapmin,' ',vmapmax);
          y:=oy1;
          for k:=vmy downto 1 do
          begin
          x:=ox1;
          for i:=1 to vmx do
          begin
          write(f,vmap[i,k],' ');
          x:=x+dx;
          end;
          y:=y+dy;
          end;
          closefile(f);
          end;

          if CheckGroupexport.Checked[1] and bkarkas then
          begin
          assignfile(f,UTF8Decode(FileNameEditexportkarkas.FileName));
          rewrite(f);
          for k:=1 to m do
          writeln(f,finish[k,1],' ',-finish[k,2],' ',finish[k,4]);
          closefile(f);
          end;

          if CheckGroupexport.Checked[2] and bsource then
          begin
          assignfile(f,UTF8Decode(FileNameEditexportsources.FileName));
          rewrite(f);
          for k:=1 to nsources do
          writeln(f,source[k,1],' ',-source[k,2],' ',source[k,3],' ',source[k,4]);
          closefile(f);
          end;

          if CheckGroupexport.Checked[3] and bsource then
          begin
          assignfile(f,UTF8Decode(FileNameEditexportplot.FileName));
          rewrite(f);
          for k:=1 to ndat do
          writeln(f,dat[k,1],' ',dat[k,2],' ',dat[k,5]);
          closefile(f);
          end;
          
          if CheckGroupexport.Checked[4] and bsmooth then
          begin
          dx:=(ox2-ox1)/(smMx-1);
          dy:=(oy2-oy1)/(smMy-1);

          assignfile(f,UTF8Decode(FileNameEditExportSmooth.FileName));
          rewrite(f);
          writeln(f,'DSAA');
          writeln(f, smMx,' ',smMy);
          writeln(f, ox1,' ',ox2);
          writeln(f, -oy2,' ',-oy1);
          writeln(f,smmin,' ',smmax);
          y:=oy1;
          for k:=smMy downto 1 do
          begin
          x:=ox1;
          for i:=1 to smMx do
          begin
          write(f,smMap[i,k],' ');
          x:=x+dx;
          end;
          y:=y+dy;
          end;
          closefile(f);
          end;

          
          end;
          end;

procedure TFormexport.EditSuffixChange(Sender: TObject);
          var s:string;
          begin
          s:=EditSuffix.Text;
          with Mainform do
          begin

          FileNameEditexportplot.FileName:=newName(FileNameOpenEditor.filename,'_plot'+s,'dat');
          FileNameEditexportsources.FileName:=newName(FileNameOpenEditor.filename,'_sources'+s,'dat');
          FileNameEditexportkarkas.FileName:=newName(FileNameOpenEditor.filename,'_karkas'+s,'dat');
          FileNameEditexportmap.FileName:=newName(FileNameOpenEditor.filename,'_wavemap'+s,'grd');
          FileNameEditexportSmooth.FileName:=newName(FileNameOpenEditor.filename,'_smooth'+s,'grd');

          end;
          end;



initialization
  {$I exportdata.lrs}

end.

