unit Smooth;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls, Spin, Main, MathWave, EditBtn;

type

  { TFormSmooth }

  TFormSmooth = class(TForm)
    ButtonCancel: TButton;
    ButtonOK: TButton;
    FloatSpinEditSmAspect: TFloatSpinEdit;
    FloatSpinEditSmWidth: TFloatSpinEdit;
    LabelSmWidth: TLabel;
    LabelSmAspect: TLabel;
    LabelSmMy: TLabel;
    LabelMx: TLabel;
    SpinEditSmMx: TSpinEdit;
    SpinEditSmMy: TSpinEdit;
    procedure ButtonOKClick(Sender: TObject);
    procedure FloatSpinEditSmAspectChange(Sender: TObject);
    procedure FloatSpinEditSmWidthChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpinEditSmMxChange(Sender: TObject);
    procedure SpinEditSmMyChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormSmooth: TFormSmooth;

implementation

{ TFormSmooth }

procedure TFormSmooth.FormCreate(Sender: TObject);
          begin
          with Check do
          begin
          SpinEditSmMx.Value:=SmMx;
          SpinEditSmMy.Value:=SmMy;
          floatSpinEditSmAspect.Value:=smAspect;
          floatSpinEditSmWidth.Value:=smWidth;
          end;
          end;

procedure TFormSmooth.ButtonOKClick(Sender: TObject);
          var k:integer;
          begin
          with check do
          Begin
          TabsmMap;
          for k:=1 to npalettemap do smiso[k]:=(smmin)+(k-1)*(smmax-smmin)/(npalettemap-1);
          end;
          end;

procedure TFormSmooth.FloatSpinEditSmAspectChange(Sender: TObject);
          begin
          check.smAspect:=FloatSpinEditSmAspect.Value;
          end;

procedure TFormSmooth.FloatSpinEditSmWidthChange(Sender: TObject);
          begin
          check.smWidth:=FloatSpinEditSmWidth.Value;
          end;

procedure TFormSmooth.SpinEditSmMyChange(Sender: TObject);
          begin
          Check.smMy:=SpinEditSmMy.Value;
          end;

procedure TFormSmooth.SpinEditSmMxChange(Sender: TObject);
          begin
          check.smMx:=SpinEditSmMx.Value;
          end;


initialization
  {$I smooth.lrs}

end.

